//
//
//  Generated by StarUML(tm) Java Add-In
//
//  @ Project : Untitled
//  @ File Name : Command.java
//  @ Date : 18/04/2007
//  @ Author : 
//
//



package bootstrapP;


/**This class represents a command got from the human interface. 
 * @author Marco Cornolti
 *
 */
public class Command {
	/** The Command type */
	private int type;
	/** May be both an hostname or a nickname, depending on the command type*/
	private String str1;
	/** The password*/
	private String str2;
	/** May be the unique MS id (for those commands involving only one MS like RemoveMS or UsersList) or the first MS id (for MoveUser)*/
	private int int1; 
	/** The second MS id*/
	private int int2; 
	
    
    /**Private Command constructor. 
     * @param type the command type.
     * @param s1 the hostname for commands of type AddMS, the nickname for commands of type DeleteUser or the file name (may be null) for the command Backup. 
     * @param s2 the User password
     * @param i1 the MS id for commands of type RemoveMS or the first MS id for commands of type MoveUser
     * @param i2 the second MS id
     */
    private Command(int type, String s1,String s2, int i1, int i2){
    	this.str1=s1;
    	this.str2=s2; 
        this.int1=i1; 
        this.int2=i2; 
    	this.type=type;
    }
    
    /**Get the hostname (for those method whose arguments has one).
     * @return the hostname
     */
    public String getHostname(){
    	return this.str1;
    }
    
    /**Get the nickname (for those method whose arguments has one).
     * @return the nickname
     */
    public String getNick(){
    	return this.str1;
    }

    /**Get the filename (for those method whose arguments has one).
     * @return the filename
     */
    public String getFilename(){
    	return this.str1;
    }
    
    /**Get the first server ID number (for those method whose arguments has one).
     * @return the first server ID
     */
    public int getId1(){
    	return this.int1;
    }

    /**Get the second server ID number (for those method whose arguments has one).
     * @return the second server ID
     */
    public int getId2(){
    	return this.int2;
    }
    
    /**Get the password (for those method whose arguments has one).
     * @return the password.
     */
    public String getPassword(){
    	return this.str2;
    }
    
    /**Get the UDP port (for those method whose arguments has one).
     * @return UDP port number.
     */
    public int getUDPPort(){
    	return this.int2;
    }

    /**Get the RMI port (for those method whose arguments has one).
     * @return RMI port number.
     */
    public int getRMIPort(){
    	return this.int2;
    }
    
    /**The command is of type "show all".
     * @return true if the command type is "show all".
     */
    public boolean isShowAll() {
        return type==1;
    }
    
    /**The command is of type "add message server".
     * @return true if the command type is "add message server".
     */
    public boolean isAddMS() {
        return type==2;
    }
    
    /**The command is of type "delete user".
     * @return true if the command type is "delete user".
     */
    public boolean isDeleteUser() {
        return type==3;
    }
    
    /**The command is of type "show global statistics".
     * @return true if the command type is "show global statistics".
     */
    public boolean isShowGlobalStats() {
        return type==4;
    }
    
    /**The command is of type "remove message server".
     * @return true if the command type is "remove message server".
     */
    public boolean isRemoveMS() {
        return type==5;
    }

    /**The command is of type "move a user to anothe message server".
     * @return true if the command type is "move a user to another message server".
     */
    public boolean isMoveUser() {
        return type==6;
    }
    
    /**The command is of type "test presence".
     * @return true if the command type is "test presence".
     */
    public boolean isTestPresence() {
        return type==7;
    }
        
    /**The command is of type "block assignation".
     * @return true if the command type is "block assignation".
     */
    public boolean isBlockAssignation() {
        return type==8;
    }
    
    /**The command is of type "shutdown".
     * @return true if the command type is "shutdown".
     */
    public boolean isShutdown() {
        return type==9;
    }
    
    /**The command is of type "list users".
     * @return true if the command type is "list users".
     */
    public boolean isUsersList() {
        return type==10;
    }
    
    /**The command is of type "unblock assignation".
     * @return true if the command type is "unblock assignation".
     */
    public boolean isUnblockAssignation() {
        return type==11;
    }
    
    /**The command is of type "backup".
     * @return true if the command type is "backup".
     */
    public boolean isBackup() {
        return type==12;
    }
        
    /**"show all" command constructor.
     * @return a command of type "show all"
     */
    public static Command makeShowAll() {
        return new Command(1,null,null,0,0);
    }
    
    /**"add message server" command constructor.
     * @return a command of type "add message server"
     * @param hostname the hostname of the message server.
     * @param password the ms password.
     * @param rmiPort the ms RMI port.
     * @param udpPort the ms UDP port.
     */
    public static Command makeAddMS(String hostname, String password, int rmiPort, int udpPort) {
        return new Command(2,hostname,password,rmiPort,udpPort);
    }
    
    
    /**"delete user" command constructor.
     * @return a command of type "delete user"
     * @param nick the user nickname.
     */
    public static Command makeDeleteUser(String nick) {
        return new Command(3,nick,null,0,0);
    }
    
    /**"show global statitics" command constructor.
     * @return a command of type "show global statistics"
     */
    public static Command makeShowGlobalStats() {
        return new Command(4,null,null,0,0);
    }
    
    /**"remove message server" command constructor.
     * @param id the ms ID number.
     * @return a command of type "remove message server"
     */
    public static Command makeRemoveMS(int id) {
        return new Command(5,null,null,id,0);
    }
    
    /**"move user" command constructor.
     * @return a command of type "move user"
     * @param nick the nickname
     * @param id the id of the server the user must be moved to.
     */
    public static Command makeMoveUser(String nick, int id) {
        return new Command(6,nick,null, id,0);
    }

    /**"test presence" command constructor.
     * @return a command of type "test presence"
     * @param id the is of the message server whose presence must be tested.
     */
    public static Command makeTestPresence(int id) {
        return new Command(7,null,null, id,0);
    }
    
    /**"block assignation" command constructor.
     * @return a command of type "block assignation"
     * @param id the ms that must be blocked.
     */
    public static Command makeBlockAssignation(int id) {
        return new Command(8,null,null, id,0);
    }
    
    /**"shutdown" command constructor.
     * @return a command of type "shutdown"
     * @param id the is of the ms that must me shut down.
     */
    public static Command makeShutdown(int id) {
        return new Command(9,null,null, id,0);
    }
    
    /**"show users list" command constructor.
     * @return a command of type "show users list"
     * @param id the id of the ms the users must be shown.
     */
    public static Command makeUsersList(int id) {
        return new Command(10,null,null, id,0);
    }

    /**"unblock assignation" command constructor.
     * @return a command of type "unblock assignation"
     * @param id the id of the server whose assignation must be unblocked.
     */
    public static Command makeUnblockAssignation(int id) {
        return new Command(11,null,null, id,0);
	}
    
    /**"backup" command constructor.
     * @return a command of type "backup"
     * @param filename the file name of the backup. 
     */
    public static Command makeBackup(String filename) {
        return new Command(12,filename,null, 0,0);
	}
    
}
