/*
 * Created on 18/apr/07
 */
package bootstrapP;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.SocketException;


/**The thread that listens for incoming load signal by the message servers
 * @author Marco Cornolti
 */
public class LoadListener extends Thread {
	private int udpPort=-1;
	
    /**
     * @param udpPort the UDP port to listen to.
     */
    public LoadListener(int udpPort) {
    	this.udpPort=udpPort;
	}

	/* (non-Javadoc)
	 * @see java.lang.Thread#run()
	 */
	public void run(){
		DatagramSocket sock=null;
		try{
        	sock = new DatagramSocket(udpPort);
		}catch (SocketException e){
			HumanListener.currentInt.showUDPProblem();
        	
		}
    	while (true){
    		DatagramPacket pkt = new DatagramPacket(new byte[512],512);
        	try{
        		sock.receive(pkt);
        	} catch (IOException e){
        		HumanListener.currentInt.showUDPProblem();
        		return;
        	}
        	
        	ManagedMessageServer ms = MessageServersDatabase.getMS(pkt.getAddress(), pkt.getPort());
        	if (ms==null){
        		HumanListener.currentInt.showMSUnknown(pkt.getAddress().getHostAddress(), pkt.getPort());
        		continue;
        	}
        	else{
        		ms.refreshLoad(new String(pkt.getData()));
        	}
        	
        }
    }
}
