//
//
//  Generated by StarUML(tm) Java Add-In
//
//  @ Project : Untitled
//  @ File Name : RegisteredUser.java
//  @ Date : 16/04/2007
//  @ Author : 
//
//



package bootstrapP;

import java.io.Serializable;

import common.*;


/**A representation of a user registered into the gossip system, witch is assigned to a message server.
 * @author Marco Cornolti
 *
 */
public class RegisteredUser implements java.lang.Comparable<Object>, Serializable {
    /**
	 * RegisteredUser version. 
	 */
	private static final long serialVersionUID = 1L;
	private String password;
    private String nickname;
    private ManagedMessageServer ms;
    
    /**
     * @param nick the user nickname.
     * @param pw the user password.
     * @param ms the message server the user is assigned to.
     */
    public RegisteredUser(String nick, String pw, ManagedMessageServer ms){
        this.password=pw;
        this.nickname=nick;
        this.ms=ms;
    }
    
    /**Checks the user password against the password given as argument.
     * @param pw the password to check.
     * @return true if the given password is right, false otherwise.
     */
    public boolean checkPassword(String pw){
        return pw.equals(password);
    }

    /**
     * @return the message server this user is assigned to.
     */
    public ManagedMessageServer getMS(){
        return ms;
    }
    /**
     * @return the user nickname.
     */
    public String getNick(){
        return nickname;
    }

    /* (non-Javadoc)
     * @see java.lang.Comparable#compareTo(java.lang.Object)
     */
    public int compareTo(Object usr2) {
        if (usr2 instanceof RegisteredUser)
            return this.nickname.compareTo(((RegisteredUser)usr2).nickname);
        else if (usr2 instanceof User)
            return this.nickname.compareTo(((User)usr2).getNick());
        else if (usr2 instanceof String)
            return this.nickname.compareTo(((String)usr2));
        return 0;
    }
    
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object usr2) {
        if (usr2 instanceof RegisteredUser)
            return this.nickname.equals(((RegisteredUser)usr2).nickname);
        else if (usr2 instanceof User)
            return this.nickname.equals(((User)usr2).getNick());
        else if (usr2 instanceof String)
            return this.nickname.equals(((String)usr2));
        return false;
    }

	/**Sets the message server this user is assigned to.
	 * @param ms the new user's message server.
	 */
	public void setMS(ManagedMessageServer ms) {
		this.ms=ms;
	}
}
