

//Generated by StarUML(tm) Java Add-In

//@ Project : Untitled
//@ File Name : TextualInterface.java
//@ Date : 19/03/2007
//@ Author : 





package bootstrapP;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;


/**The human textual interface in italian.
 * @author Marco Cornolti
 *
 */
public class TextualInterfaceIt implements HumanInterface {
    static BufferedReader in;
    static PrintStream out;

    public void initialize(){
        in = new BufferedReader(new InputStreamReader(System.in));
        out = System.out;
        out.println("Bootstrap Server - Benvenuti nell'interfaccia testuale.");
    }

    public Command getCommand() {
    	System.out.print("> ");
    	String cmdString = null;
    	String[] args = null;
    	try {
    		cmdString = in.readLine();
    		cmdString = cmdString.toLowerCase();
    		args = cmdString.split(" ");
    	}catch (IOException e){
    		out.println("Errore nell'inserimento del comando");
    	}
    	try{
    		if (args[0].equals("addms"))
    			return Command.makeAddMS(args[1], args[4], Integer.parseInt(args[2]), Integer.parseInt(args[3]));
    		else if (args[0].equals("deleteuser"))
    			return Command.makeDeleteUser(args[1]);
    		else if (args[0].equals("moveuser"))
    			return Command.makeMoveUser(args[1], Integer.parseInt(args[2]));
    		else if (args[0].equals("removems"))
    			return Command.makeRemoveMS(Integer.parseInt(args[1]));
    		else if (args[0].equals("stats"))
    			return Command.makeShowAll();
    		else if (args[0].equals("globalstats"))
    			return Command.makeShowGlobalStats();
    		else if (args[0].equals("testpresence"))
    			return Command.makeTestPresence(Integer.parseInt(args[1]));
    		else if (args[0].equals("blockassign"))
    			return Command.makeBlockAssignation(Integer.parseInt(args[1]));
    		else if (args[0].equals("unblockassign"))
    			return Command.makeUnblockAssignation(Integer.parseInt(args[1]));
    		else if (args[0].equals("shutdown"))
    			return Command.makeShutdown(Integer.parseInt(args[1]));
    		else if (args[0].equals("userslist"))
    			return Command.makeUsersList(Integer.parseInt(args[1]));
    		else if (args[0].equals("backup")){
    			if (args.length==1)
    				return Command.makeBackup(null);
    			else
    				return Command.makeBackup(args[1]);
    		}
    		else{
    			showWrongCommandName();
    			printHelp();
    			return getCommand();
    		}
    	}catch (ArrayIndexOutOfBoundsException e){
    		showWrongParametersNumber();
    		printHelp();
			return getCommand();
    	}catch (NumberFormatException e){
    		showWrongParametersFormat();
    		printHelp();
			return getCommand();
    	}
    	
    }

    /**
     * Stampa un messaggio se il nome di un comando e' errato.
     */
    private void showWrongCommandName() {
    	printWarning("Il nome del comando non e' corretto.");
    }

	/**
	 * Stampa un messaggio se la sintassi di un comando non e' corretta.
	 */
	private void showWrongParametersFormat() {
    	printWarning("I parametri del comando non sono stati immessi correttamente.");
	}

	/**
	 * Stampa un messaggio se il numero di parametri immessi per un comando e' errata.
	 */
	private void showWrongParametersNumber() {
    	printWarning("Il numero di parametri immessi non e' corretto.");
	}

	/**
	 * Stampa l'elenco dei comandi disponibili.
	 */
	private void printHelp(){
		out.println("Elenco dei comandi disponibili:");
		out.println("addms hostname rmi_port udp_port password - Aggiunge un Message Server");
		out.println("deleteuser nick - elimina un utente");
		out.println("moveuser nick MS_id- sposta un utente verso un altro message server");
		out.println("removems MS_id - elimina un Message Server, trasferendo prima gli utenti gestiti");
		out.println("stats - stampa le statistiche locali");
		out.println("globalstats - stampa le statistiche del sistema");
		out.println("testpresence MS_id - controlla la presenza del MS");
		out.println("blockassign MS_id - blocca gli assegnamenti di nuovi utenti per il MS");
		out.println("backup [filename] - salva il backup nell'unita' principale o sul file specificato");
		out.println("unblockassign MS_id - permette gli assegnamenti di nuovi utenti per il MS");
		out.println("shutdown MS_id - spenge il MS");
		out.println("userslist MS_id - interroga il MS e stampa gli utenti assegnati");
		out.println();
		out.flush();
    }
    
    
    /**Stampa i messaggi di normale interazione.
     * @param msg il messaggio da stampare.
     */
    private void printMessage(String msg){
        out.println(msg);
    }
    
    /**Stampa i messaggi di particolare rilevanza come errori degli utenti, errori del sistema globale e password sbagliate.
     * @param war il messaggio da stampare.
     */
    private void printWarning(String war){
        out.println("(WW) "+war);
    }
    
    /**Stampa i messaggi di gravi errori di sistema locali.
     * @param err il messaggio da stampare
     */
    private void printError(String err){
        out.println("(EE) "+err);
    }

    public void destroy() {
        out.println("Terminazione dell'interfaccia testuale.");
        out.flush();
    }

	public void showMSNotRemoved(int id1) {
		printWarning("Impossibile rimuovere il message server "+id1);
	}

	public void showMSRemoved(int id1) {
		printMessage("Rimosso il message server "+id1);
	}

	public void showReceivedLoad(String hostname, int freeMem, int fwdMess) {
		printMessage("Ricevuto il carico dal MS "+hostname+" -  Memoria: "+freeMem+" Messaggi Inoltrati: "+fwdMess+".");
	}

	public void showUserDeleted(String nick) {
		printMessage("Eliminato l'utente "+nick);
	}

	public void showUserMoved(String nick) {
		printMessage("Spostato l'utente "+nick);
	}

	public void showUserNotDeleted(String nick) {
		printWarning("Impossibile eliminare l'utente "+nick);
	}

	public void showUserNotExists(String nick) {
		printWarning("L'utente "+nick+" non esiste.");
	}

	public void showUserNotMoved(String nick) {
		printWarning("Impossibile spostare l'utente "+nick);
	}

	public void showCouldNotContactMS(String hostname, int udpPort, int rmiPort) {
		printWarning("L'hostname " + hostname+":"+udpPort+":"+rmiPort+" non e' corretto o non e' stato possibile contattarlo.");
	}

	public void showUDPProblem() {
		printError("Errore nel socket UDP.");
	}

	public void showGlobalMSStats(int mss, long minFreeMem, int minFreeMemI, String minMemCanonicalHostName, long maxFreeMem, int maxFreeMemI, String maxMemCanonicalHostName, int minManUsers, int minManUsersI, String minUsersCanonicalHostName, int maxManUsers, int maxManUsersI, String maxUsersCanonicalHostName, long fwMsgs, long onlineUsers, long queuedMsgs) {
		printMessage("--- Riassunto delle statistiche globali di sistema ---\n\nTotale Message Server: "+mss+"\n- Minimo memoria\nServer "+minMemCanonicalHostName+" (id "+minFreeMemI+")\nMemoria disponibile: "+minFreeMem+" bytes.\n\n- Massimo memoria\nServer "+maxMemCanonicalHostName+" (id "+maxFreeMemI+")\nMemoria disponibile: "+maxFreeMem+" bytes.\n\n- Minimo utenti gestiti\nServer "+minUsersCanonicalHostName+" (id "+minManUsersI+")\nUtenti gestiti: "+minManUsers+".\n\n- Massimo utenti gestiti\nServer "+maxUsersCanonicalHostName+" (id "+maxManUsersI+")\nUtenti gestiti: "+maxManUsers+".\n\n- Totale messaggi inoltrati: " + fwMsgs+"\n- Utenti on-line: "+ onlineUsers+"\n- Messaggi in coda nei message server: "+queuedMsgs+"\n\n");
	}


	public void showSingleMSStats(int i, String canonicalHostName, int RMIport, int UDPport, int cacheEntries, long freeMem, long load, int forwardedMessagesMinute, int forwardedMessagesHour, int forwardedMessages24Hours, int forwardedMessages144Hours, int managedUsers, int onlineManagedUsers, int queuedMessageNumber) {
		printMessage("- Statistiche per il message server "+canonicalHostName+"(id "+i+")\n"+"Porta RMI: "+RMIport+" Porta UDP: "+UDPport+"\nCarico: "+load+"\nRecord nella cache: "+cacheEntries+"\nMemoria libera: "+freeMem+" bytes\n- Messaggi inoltrati:\n Nell'ultimo minuto: "+forwardedMessagesMinute+"\n Nell'ultima ora: "+forwardedMessagesHour+"\n Nelle ultime 24h: "+forwardedMessages24Hours+"\n Nell'ultima settimana (144h): "+forwardedMessages144Hours+"\nUtenti assegnati: "+managedUsers+"\nUtenti assegnati on-line:"+onlineManagedUsers+"\nMessaggi in coda: "+queuedMessageNumber);
	}

	public void showStatistics(long upTime, int usersNumber, int MSnumber) {
		printMessage("- Statistiche per il Bootstrap server\nUptime: "+upTime/1000+" secondi.\nNumero utenti registrati: "+usersNumber+"\nNumero dei Message Server attivati: "+MSnumber);
	}

	public void showReceivedLoadFailed() {
		printMessage("E' arrivato un pacchetto UDP ma non si e' stati in grado di leggerne il contenuto.");
	}

	public void showMSAdded(String canonicalHostName, int udpPort, int rmiPort) {
		printMessage("Contattato e aggiunto il Message Server "+canonicalHostName+":"+udpPort+":"+rmiPort);
	}

	public void showWrongMSPassword(String host, int udpPort, int rmiPort) {
		printWarning("E' errata la password per il server "+host+":"+udpPort+":"+rmiPort+".");
	}

	public void showMSBlocked(int id1) {
		printMessage("Il Message Server con id "+id1+" e' bloccato.");
	}

	public void showCouldNotShutdownUnblockedMS(int id1) {
		printMessage("Impossibile spegnere il Message Server con id "+id1+". Bloccare prima il server.");
	}

	public void showMSCommunicationProblem(int id1) {
		printWarning("Errore nella comunicazione col Message Server id "+id1+".");
	}

	public void showMSShutdownDone(int id1) {
		printMessage("Message server id "+id1+" spento con successo.");
	}

	public void showTestPresenceDone(int id1) {
		printMessage("Test di presenza andato a buon fine per il Message Server "+id1);
	}

	public void showTestPresenceFailed(int id1) {
		printWarning("Fallito il test di presenza per il Message Server "+id1);
	}

	public void showUserList(int id1, String userStr) {
		printMessage("Elenco degli utenti per il Message Server "+id1+"\n"+userStr);
	}

	public void showWrongMSId(int id1) {
		printWarning(id1+" non e' un Id valido per un Message Server.");
	}

	public void showWrongMSPassword(int id1) {
		printWarning("Password del Message Server "+id1+" errata.");
	}

	public void showMSUnblocked(int id1) {
		printMessage("Riattivata l'assegnazione di nuovi utenti per il MS "+id1);
	}

	public void showMSUnknown(String hostAddress, int port) {
		printWarning("Ricevuto un pacchetto udp da un server sconosciuto ("+hostAddress+":"+port+").");
	}

	public void showUserNotManaged(int managerMSi, String user) {
		printError("Si e' provato ad eseguire un'operazione sull'utente "+user+" sul server "+managerMSi+", ma secondo questo server l'utente non e' gestito da lui.");
		
	}

	public void showMSGenericError(int msId) {
		printWarning("Il Message Server "+msId+" ha risposto con un errore generico.");
	}

	public void showMSShutdownFailedUsersPresent(int id) {
		printWarning("Impossibile spengere il Message Server "+id+" dato che gestisce ancora utenti.");
	}

	public void showMSUserNotAccepted(int id, String nick) {
		printWarning("Il Message Server "+id+" si e' rifiutato di prendere in gestione l'utente "+nick+".");
	}

	public void showIllegalArgument(String hostname, int UDPport, int RMIport) {
		printWarning("Uno dei dati immessi non e' valido. Hostname: "+hostname+" UDP port: "+UDPport+" RMI port: "+RMIport);
	}

	public void showCouldNotBackupMS(String hostname, int RMIport, int UDPport) {
		printError("Attenzione: impossibile eseguire il backup del message server [hostname:"+hostname+" portaRmi:"+RMIport+" portaUdp:"+UDPport+"]. Se si il supporto del backup e' un disco, probabilmente e' pieno o danneggiato. Se il supporto e' remoto, probabilmente la comunicazione ha avuto dei problemi.\nPer il corretto funzionamento e' necessario, una volta risolto il problema, eseguire il comando 'backup'.");
	}

	public void showCouldNotBackupUser(String nickname) {
		printError("Attenzione: impossibile eseguire il backup dell'utente [nickname:"+nickname+"]. Se si il supporto del backup e' un disco, probabilmente e' pieno o danneggiato. Se il supporto e' remoto, probabilmente la comunicazione ha avuto dei problemi.\nPer il corretto funzionamento e' necessario, una volta risolto il problema, eseguire il comando 'backup'.");
	}

	public void showCouldNotRemoveBackuppedMS(String hostName, int RMIport, int UDPport) {
		printError("Attenzione: impossibile eliminare dal backup il message server [hostname:"+hostName+" portaRmi:"+RMIport+" portaUdp:"+UDPport+"]. Se si il supporto del backup e' un disco, probabilmente e' pieno o danneggiato. Se il supporto e' remoto, probabilmente la comunicazione ha avuto dei problemi.\nPer il corretto funzionamento e' necessario, una volta risolto il problema, eseguire il comando 'backup'.");
	}

	public void showCouldNotRemoveBackuppedUser(String nick) {
		printError("Attenzione: impossibile eliminare dal backup l'utente [nickname:"+nick+"]. Se si il supporto del backup e' un disco, probabilmente e' pieno o danneggiato. Se il supporto e' remoto, probabilmente la comunicazione ha avuto dei problemi.\nPer il corretto funzionamento e' necessario, una volta risolto il problema, eseguire il comando 'backup'.");
	}

	public void showBackupDone() {
		printMessage("Backup terminato.");
	}

	public void showBackupFileStart(String filename) {
		printMessage("Inizio backup sul file "+filename+".");
	}

	public void showBackupStart() {
		printMessage("Inizio backup sul backupper di default.");
	}

	public void showBackupFailed() {
		printError("Impossibile terminare il backup con successo. Errore nel trasferimento dei dati (disco pieno, permessi insufficienti o errore di comunicazione)");
	}

	public void showUserMoveSameDest(String nick) {
		printWarning("Attenzione: si sta tentando di spostare l'utente "+nick+" nel message server da cui e' gia' gestito.");
	}

	public void showMSAlreadyInseted() {
		printWarning("Attenzione: il message server indicato e' gia parte di questo sistema Gossip.");
		
	}



}
