//
//
//  Generated by StarUML(tm) Java Add-In
//
//  @ Project : Untitled
//  @ File Name : User.java
//  @ Date : 10/03/2007
//  @ Author : 
//
//



package common;

import java.io.Serializable;
import java.net.InetAddress;
import java.net.UnknownHostException;


/**A representatin of a Gossip user.
 * @author Marco Cornolti and Alessandro Franchini
 */
public class User implements Serializable, Cloneable, Comparable<Object>{
	private static final long serialVersionUID = 1L;
	private String nick;
	private java.net.InetAddress ip;
	private int port;
	private Boolean state;
    private Boolean friend;
    private int connection=0;
    
   
    /**
     * @param name the user's nickname.
     * @param ip the users' ip.
     * @param port the user's TCP port.
     * @param state the user's state (true if online).
     * @param friend true if the user is a friend (only needed if the user is contained in a contact list)
     */
    public User(String name, InetAddress ip, int port, Boolean state, Boolean friend){
    	this.nick = name;
    	this.ip = ip;
    	this.port= port;
    	this.state = state;
    	this.friend=friend;
    }
    
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object u2){
        if (! (u2 instanceof User)) return false;
        return this.nick.equals(((User)u2).nick);
    }
    
	/**
	 * @return the user nickname.
	 */
	public String getNick() {
	    return this.nick;
	}
	
	/**
	 * @return the user's IP address.
	 */
	public java.net.InetAddress getIP() {
	    return this.ip;
	}
	
    /**
     * @return the user TCP port.
     */
    public int getPort() {
        return this.port;
    }
    /**Sets the name of this user.
     * @param name the name.
     */
    public void setName(String name){
    	this.nick= name;
    }

    /**Sets the TCP port of the user.
     * @param port the user port.
     */
    public void setPort(int port){
    	this.port= port;
    }

    /**Sets the user IP address.
     * @param ip
     */
    public void setIp(InetAddress ip){
    	this.ip= ip;
    }
    /**
     * @return true only if the user is on-line.
     */
    public boolean isOnline() {
        return this.state;
    }
    /**
     * @return true if the user is a friend (only if contained in a contact list)
     */
    public Boolean isFriend(){
        return this.friend;
    }
    
    /**Sets the user state.
     * @param state true if on-line, false if off-line.
     */
    public void setOnline(boolean state){
        this.state=state;
        if (!state){
        	this.ip=null;
            this.port=0;
        }
    }
    /**Sets the user friendness. (only considered if the user is contained in a contact list)
     * @param friend the user friendness.
     */
    public void setFriend(Boolean friend){
    	this.friend=friend;
    }
    /**
     * @return the connection number.
     */
    public int getConn(){
    	return this.connection;
    }
    /**Sets the connection number.
     * @param status the connection number.
     */
    public void setConn(int status){
    	this.connection= status;
    }
    /* (non-Javadoc)
     * @see java.lang.Object#clone()
     */
    public User clone(){
    	User u=null;
        try{
        	u = new User(new String(nick), null, port, state, friend);
        	if (this.ip != null) u.setIp(InetAddress.getByAddress(ip.getAddress()));
        }catch (UnknownHostException e){
        	e.printStackTrace();
        	System.exit(1);
        }        
        u.connection=this.connection;
        return u;
    }

	/**Compares this user (usr1) with usr2 by their nicknames.
	 * @param usr2 the user to compare to.
	 * @return >0 if the usr2 comes alphabetically after usr1, 0 if their name are the same, less than 0 otherwise. 
	 */
	public int compareTo(Object usr2) {
		return this.nick.compareTo(((User)usr2).nick);
	}
}
