//
//
//  Generated by StarUML(tm) Java Add-In
//
//  @ Project : Untitled
//  @ File Name : MSForMSInterface.java
//  @ Date : 19/03/2007
//  @ Author : 
//
//



package common.interfaces;

import java.rmi.Remote;
import java.rmi.RemoteException;

import common.User;
import common.interfaces.exceptions.*;

/** This interface provides the methods that the object exported by a Message Server must provide to let another
 * Message Server communicate with it.
 * @author Marco Cornolti and Alessandro Franchini
 */
public interface MSForMSInterface extends Remote{
	
	/**Forwards a message from a Message Server to this one.
	 * @param msg the message to forward.
	 * @throws RemoteException if a communication problem occurs.
	 * @throws NotAllowedException if the recipint does not accept messages from the sender.
	 * @throws UserNotManagedException id the recipient user is not assigned to this MS. 
	 * @throws GenericErrorException if a generic error occurred.
	 * @throws UserNotExistsException if the user does not exist in the whole system.
	 * @throws SystemErrorException if a system error occurred.
	 */
	public abstract void forwardMessage(common.Message msg) throws RemoteException, NotAllowedException, UserNotManagedException, GenericErrorException, UserNotExistsException, SystemErrorException;
		
	
	/**Checks whether or not a user (U1) accepts messages sent from another user (U2)
	 * @param listUser the receiver user (U1)
	 * @param user the sender user (U2)
	 * @return true if, and only if, listUser (U1) accepts messages from user (U2).
	 * @throws RemoteException if a communication problem occurred.
	 * @throws UserNotManagedException if the listUser (U1) is not managed by the server.
	 */
	public abstract boolean inListOfUserContains(common.User listUser, common.User user) throws RemoteException, UserNotManagedException;
	
	/**Assigns a user management (sending all its datas) to the message server.
	 * @param user the user to assign.
	 * @throws AssignationNotAcceptedException if the assignation was not accepted. 
	 * @throws RemoteException if a communication problem occurred.
	 */
	public abstract void assignMovedUser(messageServerP.ManagedUser user) throws RemoteException, AssignationNotAcceptedException;
	
	/**Gets a User IP address and TCP port to directely connect to its servlet. The User is managed by this MS.
	 * @param user the user whose connection datas is wanted. Only the nickname is considered. 
	 * @return the user with the correctly obtained IP address and TCP port. 
	 * @throws RemoteException if a communication problem occurs.
	 * @throws UserNotManagedException if the user is not locally managed.
	 */
	public abstract common.User getManagedUserContact(User user) throws RemoteException, UserNotManagedException;
	
}
