

//Generated by StarUML(tm) Java Add-In

//@ Project : Untitled
//@ File Name : TextualInterface.java
//@ Date : 19/03/2007
//@ Author : 





package messageServerP;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;

import common.*;


/**A textual interface in italian.
 * @author Marco Cornolti
 *
 */
public class TextualInterfaceIt implements HumanInterface {
	static BufferedReader in;
	static PrintStream out;

	/* (non-Javadoc)
	 * @see messageServerP.HumanInterface#initialize()
	 */
	public void initialize(){
		in = new BufferedReader(new InputStreamReader(System.in));
		out = System.out;
		out.println("Message Server - Benvenuti nell'interfaccia testuale.");
	}

	public Command getCommand() {
		System.out.print("> ");
		String cmdString=null;
		String[] args=null;
		try {
			cmdString = in.readLine();
			cmdString = cmdString.toLowerCase();
			args = cmdString.split(" ");
		}catch (IOException e){
			out.println("Errore nell'inserimento del comando");
		}

		try{
			if (args[0].equals("loadstats")){
				return Command.makePrintLoadStatistics();
			}
			else if (args[0].equals("usersstats")){
				return Command.makePrintUsersStatistics();
			}
			else if (args[0].equals("gui")){
				return Command.makeChangeInterfaceToGUI();
			}
			else if (args[0].equals("shutdown")){
				return Command.makeShutdown();
			}
			else if (args[0].equals("backup")){
				return Command.makeBackup(args[1]);
			}
			else{
				showWrongCommandName();
				printHelp();
				return getCommand();
			}
		} catch (ArrayIndexOutOfBoundsException e){
			showWrongParametersNumber();
			printHelp();
			return getCommand();
		}

	}

	private void showWrongCommandName() {
		printWarning("Il nome del comando non e' corretto.");
	}

	private void showWrongParametersNumber() {
		printWarning("I parametri del comando non sono di numero esatto.");
	}

	/**
	 * Stampa l'elenco dei comandi e la loro sintassi.
	 */
	private void printHelp(){
		out.println("Elenco dei comandi disponibili:");
		out.println("loadstats - stampa le statistiche relative al Message Server");
		out.println("usersstats - stampa le statistiche relative agli utenti del Message Server");
		out.println("gui - cambia l'interfaccia da testuale a grafica");
		out.println("shutdown - spenge brutalmente il server");
		out.println();
		out.flush();
	}
	public void showAddAlreadyInserted(String user, String userToAdd) {
		printMessage("Utente "+userToAdd+" gia' inserito nella lista di "+user+".");
	}

	public void showAddToFriendDone(String user, String userToAdd) {
		printMessage("Utente "+userToAdd+" correttamente inserito nella lista degli amici di "+user+".");
	}

	public void showAddToFriendRequest(String user, String userToAdd) {
		printMessage("Richiesta di inserire "+userToAdd+" nella lista degli amici di "+user+".");
	}

	public void showAddToOutDone(String user, String userToAdd) {
		printMessage("Richiesta di inserire "+userToAdd+" nella lista dei contatti in uscita di "+user+" accettata.");
	}

	public void showAddToOutNotAllowed(String user, String userToAdd) {
		printMessage("Richiesta di inserire "+userToAdd+" nella lista dei contatti in uscita di "+user+" non consentita.");
	}

	public void showAddToOutRequest(String user, String userToAdd) {
		printMessage("L'utente "+user+" ha richiesto di inserire "+userToAdd+" nella lista dei contatti in uscita.");
	}

	public void showAdminDeletionDone(String nick) {
		printMessage("L'utente "+nick+" e' stato eliminato dall'amministratore.");
	}

	public void showAdminDeletionRequest(String nick) {
		printMessage("Richiesta dall'amministratore di eliminare l'utente "+nick+".");
	}

	public void showAdminWrongPassword() {
		printMessage("Password dell'amministratore sbagliata.");
	}

	public void showAssignMovedDone(String nick) {
		printMessage("Il trasferimento a questo server di "+nick+" e' completa.");
	}

	public void showAssignMovedRequest(String nick) {
		printMessage("Richiesta di trasferimento a questo server di "+nick+".");
	}

	public void showAssignationBlocked() {
		printMessage("Assegnamento di nuovi utenti bloccato.");
	}

	public void showAssignationUnblocked() {
		printMessage("Assegnamento di nuovi utenti riattivato.");
	}
	public void showAssignationDone(String nick) {
		printMessage("Richiesta di assegnamento del nuovo utente "+nick+" accettata."); 
	}

	public void showAssignationRequest(String nick) {
		printMessage("Richiesta di assegnamento del nuovo utente "+nick+".");
	}

	public void showChangePasswordDone(String nick) {
		printMessage("Cambiamento della password per "+nick+" accettata.");
	}

	public void showChangePasswordRequest(String nick) {
		printMessage("Richiesta di cambiamento della password per "+nick+".");
	}

	public void showContactListDone(String user) {
		printMessage("Innviata la lista dei contatti di "+user+".");
	}

	public void showContactListRequest(String user) {
		printMessage("Richiesta di invio della lista dei contatti di "+user+".");
	}

	public void showDeleteDownloadedDone(String nick) {
		printMessage("Cancellazione dei messaggi gia' scaricati di "+nick+".");
	}

	public void showDeleteDownloadedRequest(String nick) {
		printMessage("Richiesta di cancellazione dei messaggi gia' scaricati di "+nick+".");
	}

	public void showDeleteUserDone(String nick) {
		printMessage("L'utente "+nick+" ha cancellato il proprio account.");
	}

	public void showDeleteUserRequest(String nick) {
		printMessage("Richiesta dall'utente "+nick+" di cancellare il proprio account.");    
	}

	public void showDownloadDone(String nick) {
		printMessage("L'utente "+nick+" ha scaricato i messaggi.");                 
	}

	public void showDownloadRequest(String nick) {
		printMessage("Richiesta dall'utente "+nick+" di scaricare i messaggi.");         
	}

	public void showForwardCacheDone(String from, String to, int length) {
		printMessage("Messaggio da "+from+" a "+to+" lungo "+length+" inviato tramite cache.");         
	}

	public void showForwardDone(String from, String to, int length) {
		printMessage("Messaggio da "+from+" a "+to+" lungo "+length+" inviato correttamente.");         
	}

	public void showForwardLocalDone(String from, String to, int length) {
		printMessage("Messaggio da "+from+" lungo "+length+" consegnato all'utente locale "+to+".");         
	}

	public void showForwardNotAllowed(String from, String to, int length) {
		printMessage("Messaggio da "+from+" a "+to+" lungo "+length+" non ammesso.");         
	}

	public void showForwardRequest(String from, String to, int length) {
		printMessage("Richiesta di inoltro messaggio da "+from+" a "+to+" lungo "+length+".");         
	}

	public void showInListOfUserContainsDone(String listNick, String nick2, boolean contains) {

		if (contains) printMessage("Risposta: "+listNick+" accetta messaggi da "+nick2+".");
		else printMessage("Risposta: "+listNick+" non accetta messaggi da "+nick2+".");
	}

	public void showInListOfUserContainsRequest(String listNick, String nick2) {
		printMessage("Richiesta di accettazione di"+listNick+" da parte di"+nick2+".");         
	}

	public void showMoveDone(String nick, String messageServer) {
		printMessage("Spostamento di "+nick+" al Message Server "+messageServer+" effettuato.");

	}

	public void showMoveRequest(String nick, String messageServer) {
		printMessage("Richiesta di spostamento di "+nick+" al Message Server "+messageServer+".");
	}

	public void showSendLoad(String sendingData) {
		printMessage("Invio delle informazioni sul carico al Bootstrap: ["+sendingData+"].");
	}

	public void showSendLoadTransferProblem() {
		printError("Errore nell'invio delle informazioni sul carico al Bootstrap.");
	}

	public void showSetStatusDone(String nick, boolean state) {
		if (state) printMessage("L'utente "+nick+" si e' connesso.");
		else printMessage("L'utente "+nick+" si e' disconnesso.");
	}

	public void showSetStatusRequest(String nick, boolean state) {
		if (state) printMessage("Richiesta da parte di "+nick+" di cambiare stato in on-line");
		else printMessage("Richiesta da parte di "+nick+" di cambiare stato in off-line");
	}

	public void showStatsRequest() {
		printMessage("Richiesta di invio statistiche");
	}

	public void showTestPortsDone(int port, String hostAddress) {
		printMessage("Completato con successo il testing delle porte per "+hostAddress+":"+port);
	}

	public void showTestPortsFailed(int port, String hostAddress) {
		printWarning("Fallito il testing delle porte per "+hostAddress+":"+port);
	}

	public void showTestPortsRequest(int port, String hostAddress) {
		printMessage("Richiesta di testing delle porte per "+hostAddress+":"+port);
	}

	public void showTestPresence() {
		printMessage("Richiesta di segnalazione di presenza.");
	}

	public void showUDPSocketProblem() {
		printError("Impossibile aprire una porta UDP per l'invio di dati.");
	}

	public void showUserBlocked(String nick) {
		printWarning("Utente "+nick+" bloccato.");
	}

	public void showUsersListDone() {
		printMessage("Invio della lista utenti gestiti terminato.");
	}

	public void showUsersListRequest() {
		printMessage("Richiesta di invio della lista utenti gestiti.");
	}

	public void showWrongUser(String user) {
		printWarning("L'utente "+ user+" non e' gestito da questo Message Server.");
	}

	public void showWrongUserPassword(String nick) {
		printWarning("Tentativo di login fallito (password errata) per l'utente "+ nick+".");
	}

	public void showShutDownFailedUsers() {
		printWarning("Respinta la richiesta di spengere il Message Server. Prima gli utenti assegnati devono essere trasferiti su altri Message Server.");
	}

	public void showShutdownDone() {
		printMessage("Il server sta per essere spento.");
	}

	public void showShutdownRequest() {
		printMessage("Ricevuta richiesta di spegnimento.");
	}


	public void showUsersStats(int managedUsers, int onlineManagedUsers, ManagedUser[] users) {
		String userStats = " --- Statistiche degli utenti ---\nNome\t\tstato\t\tHost:porta\n\n";

		for (int i=0; i<users.length;i++){
			User usr = users[i];
			userStats += usr.getNick()+"\t\t";
			if (usr.isOnline()) userStats += "on-line";
			else userStats+="off-line";

			userStats+="\t\t";
			if (usr.getIP()!=null) userStats+= usr.getIP().getHostAddress();
			else userStats+="unknown";
			userStats+=":"+usr.getPort()+"\n";	
		}

		userStats+="\nRiassunto statistiche:\n"+managedUsers+" utenti gestiti, di cui "+onlineManagedUsers+" on-line e "+(managedUsers-onlineManagedUsers)+" offline.";
		printMessage(userStats);
	}

	public void showLoadStats(Statistics currentStats, String bsHost, int bsRmiPort, int bsUdpPort) {
		String loadStats= " --- Statistiche di carico ---\n";
		loadStats += "Record nella cache (corrispondenze utente-ms): "+currentStats.getCacheEntries()+".\n";
		loadStats += "Memoria libera della Virtual Machine: "+currentStats.getFreeMem()+".\n";
		loadStats += "Utenti gestiti: "+currentStats.getManagedUsers()+" di cui "+currentStats.getOnlineManagedUsers()+" online.\n";
		loadStats += "Messaggi in coda: "+currentStats.getQueuedMessageNumber()+".\n";
		loadStats += " - Messaggi inoltrati: \n";
		loadStats += "nell'ultimo minuto: "+currentStats.getForwardedMessagesMinute()+"\n";
		loadStats += "nell'ultima ora: "+currentStats.getForwardedMessagesHour()+"\n";
		loadStats += "nelle ultime 24 ore: "+currentStats.getForwardedMessages24Hours()+"\n";
		loadStats += "nelle ultime 48 ore: "+currentStats.getForwardedMessages48Hours()+"\n";
		loadStats += "nelle ultime 72 ore: "+currentStats.getForwardedMessages72Hours()+"\n";
		loadStats += "nelle ultime 96 ore: "+currentStats.getForwardedMessages96Hours()+"\n";
		loadStats += "nelle ultime 120 ore: "+currentStats.getForwardedMessages120Hours()+"\n";
		loadStats += "nelle ultime 144 ore: "+currentStats.getForwardedMessages144Hours()+"\n";
		printMessage(loadStats);
	}


	/**Stampa i messaggi di normale interazione.
	 * @param msg il messaggio da stampare.
	 */
	private void printMessage(String msg){
		out.println(msg);
	}

	/**Stampa i messaggi di particolare rilevanza come errori degli utenti, errori del sistema globale e password sbagliate.
	 * @param war il messaggio da stampare.
	 */
	private void printWarning(String war){
		out.println("(WW) "+war);
	}

	/**Stampa i messaggi di gravi errori di sistema locali.
	 * @param err il messaggio da stampare
	 */
	private void printError(String err){
		out.println("(EE) "+err);
	}

	public void destroy() {
		out.println("Terminazione dell'interfaccia testuale.");
		out.flush();
	}

	public void showBlockContactDone(String nick, String nick2) {
		printMessage("L'utente "+nick+" ha bloccato con successo l'utente "+nick2);
	}

	public void showBlockContactFailedNotExists(String nick, String nick2) {
		printWarning("Tentativo dell'utente "+nick+" di bloccare l'utente "+nick2+" fallito: L'utente "+nick2+" non e' presente nella lista.");
	}

	public void showBlockContactRequest(String nick, String nick2) {
		printMessage("Ricevuta la richiesta da parte dell'utente "+nick+" di bloccare l'utente "+nick2);	
	}

	public void showRemoveContactDone(String nick, String nick2) {
		printMessage("L'utente "+nick+" ha rimosso con successo "+nick2+" dalla sua lista dei contatti.");
	}

	public void showRemoveContactRequest(String nick, String nick2) {
		printMessage("Ricevuta la richiesta da parte dell'utente "+nick+" di eliminare l'utente "+nick2+" dalla propria lista dei contatti.");	
	}

	public void showSystemError(User user) {
		printWarning("Attenzione: errore di coerenza nel sistema. L'utente "+user+" secondo il Bootstrap server e' assegnato ad un Message Server che pero' nega avere in gestione l'utente.");
	}

	public void showGetContactCache(String nick) {
		printMessage("Richiesta del contatto di "+nick+" inoltrata ad altro message server tramite cache.");
	}

	public void showGetContactDone(String nick) {
		printMessage("Contatto di "+nick+" inviato con successo.");
	}

	public void showGetContactRequest(String nick) {
		printMessage("Richiesta del contatto di "+nick+".");
	}

	public void showGetManagedContactDone(String nick) {
		printMessage("Richiesta del contatto di "+nick+" gestito localmente servita con successo.");
	}

	public void showGetManagedContactRequest(String nick) {
		printMessage("Richiesta del contatto di "+nick+" gestito localmente.");		
	}

	public void showGetManagedContactUserNotManaged(String nick) {
		printMessage("Richiesta del contatto di "+nick+" gestito localmente fallita: l'utente non e' gestito localmente.");		
	}





	public void showCouldNotBackupUser(String nickname) {
		printError("Attenzione: impossibile eseguire il backup dell'utente [nickname:"+nickname+"]. Se il supporto del backup e' un disco, probabilmente e' pieno o danneggiato. Se il supporto e' remoto, probabilmente la comunicazione ha avuto dei problemi.\nPer il corretto funzionamento e' necessario, una volta risolto il problema, eseguire il comando 'backup'.");
	}

	public void showCouldNotRemoveBackuppedUser(String nick) {
		printError("Attenzione: impossibile eliminare dal backup l'utente [nickname:"+nick+"]. Se il supporto del backup e' un disco, probabilmente e' pieno o danneggiato. Se il supporto e' remoto, probabilmente la comunicazione ha avuto dei problemi.\nPer il corretto funzionamento e' necessario, una volta risolto il problema, eseguire il comando 'backup'.");
	}

	public void showBackupDone() {
		printMessage("Backup terminato.");
	}

	public void showBackupFileStart(String filename) {
		printMessage("Inizio backup sul file "+filename+".");
	}

	public void showBackupStart() {
		printMessage("Inizio backup sul backupper di default.");
	}

	public void showBackupFailed() {
		printError("Impossibile terminare il backup con successo. Errore nel trasferimento dei dati (disco pieno, permessi insufficienti o errore di comunicazione)");
	}


}
