package servlet;
import java.net.InetAddress;
import java.net.UnknownHostException;

import common.Bootstrap;
import common.MessageServer;
import common.User;


/**
 * This is the main.
 * @author Alessandro Franchini
 *
 */
public class ClientCore {
	/** 
	 * The variables contain information about the user, the user's password,
	 * th bootstrap server, the message server and the reference to the graphic interface.
	 * 	 
	 */
	public static User myself;
	public static String pwd;
	public static Bootstrap server;
	public static GossipInterface gi;
	public static MessageServer ms;
	/**
	 * @param args 1) Indirizzo IP server
	 * 		  2) Porta server
	 * 		  3) Porta peer
	 */
	public static void main(String[] args) {
		if(args.length!=3) {
			System.out.println("Gossip Client launching syntax:\n gossip bootstrap_ip bootstrapRmi_port client_port");
			System.exit(-1);
		}
		try {
			server = new Bootstrap(args[0],Integer.parseInt(args[1]),0);
		} catch (UnknownHostException e) {
			System.out.println("The server does not exist.");
		}
		try {
			int port = Integer.parseInt(args[2]);
			if(port>65000)
				return;
			myself = new User(null,InetAddress.getLocalHost(),port,null,null);
		} catch (NumberFormatException e) {
			System.out.println("The port is wrong");
			return;
		} catch (UnknownHostException e) {
			System.out.println("The host does not exist.");
			return;
		}
		gi = new GossipInterface();
		gi.pack();
		gi.setVisible(true);
		
	}
		
}