package servlet;
import java.io.IOException;

import common.User;

/**
 * This class keeps information about the open communications.
 * @author Alessandro Franchini
 *
 */
public class Connection {
	public User name;
	public PeerInterface pi;
	public PeerCommunication ti;
	
	/**
	 * The constructor
	 * @param name the user
	 * @param ti the communications thread
	 * @param pi the graphic interface
	 */
	public Connection(User name,PeerCommunication ti, PeerInterface pi){
		this.name=name;
		this.pi = pi;
		this.ti = ti;
	}
	
	/**
	 * This method closes the connection.
	 *
	 */
	public void closeConnection(){
		try {
			ti.so.close();
			pi.dispose();
		} catch (IOException e) {
			
		}
	}
}
