package servlet;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.net.Socket;

import common.Message;
import common.User;


/**
 * This thread magages the communication with another user.
 * @author Alessandro Franchini
 *
 */
public class PeerCommunication extends Thread{
	public Socket so;
	public PeerInterface pi;
	
	/**
	 * The constructor
	 * @param soc the socket
	 * @param name the user
	 * @param mx the first received message
	 */
	public PeerCommunication(Socket soc, User name, Message mx){
		if(soc==null){
			OutputStream os;
			try {
				so = new Socket(name.getIP(),name.getPort());
				os = so.getOutputStream();
				ObjectOutputStream ois = new ObjectOutputStream(os);
				Message message = new Message("",name,ClientCore.myself);
				ois.writeObject(message);
			} catch (Exception e){
				System.out.println("The user is offline");
			}
		}
		else{
			this.so=soc;
		}
		if(name.getConn()==0){
			GossipInterface.utenti.getUser(name.getNick()).setConn(1);
			pi = new PeerInterface(this, name);
			pi.setVisible(true);
			GossipInterface.conn.addElement(new Connection(name,this,pi));
			if(mx!=null && !mx.getText().equals(""))
				this.pi.printMex(mx.getText(),mx.getFrom().getNick(), mx.getDate().toString());
		}
		else{
			for(int i = 0;i<GossipInterface.conn.size();i++){
				if(GossipInterface.conn.get(i).name.getNick().equals(name.getNick())){
					this.pi = GossipInterface.conn.get(i).pi;
					this.pi.tread = this;
					GossipInterface.conn.get(i).ti = this;
					if(mx!=null && !mx.getText().equals(""))
						this.pi.printMex(mx.getText(),mx.getFrom().getNick(), mx.getDate().toString());
				}
			}
		}
		
	}
	
	/**
	 * Thus method sends a message to the user.
	 * @param mx the message
	 */
	public void sendMex(Message mx){
		try {
			OutputStream is = so.getOutputStream();
			ObjectOutputStream oos = new ObjectOutputStream(is);
			oos.writeObject(mx);
		} catch (Exception e) {
			try {
				so = new Socket(mx.getTo().getIP(),mx.getTo().getPort());
				OutputStream os = so.getOutputStream();
				ObjectOutputStream oos = new ObjectOutputStream(os);
				oos.writeObject(mx);
				PeerCommunication tt = new PeerCommunication(so,mx.getTo(),null);
				tt.start();
			} catch (Exception e1) {
				AccessOperation.sendMessage(mx);
			}
		}
	}
	
	/**
	 * Receives messages and prints them in the graphic interface
	 */
	public void run(){
		try{
			while(true){
				InputStream is = so.getInputStream();
				ObjectInputStream ois = new ObjectInputStream(is);
				Message receive = (Message) ois.readObject();
				pi.printMex(receive.getText(),receive.getFrom().getNick(),receive.getDate().toString());
			}	
		} 
		catch (Exception io){
			System.out.println("The user closed a socket");
		}
	}

}
