package servlet;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import common.Message;
import common.User;


/**
 * This graphic interface manages the communication between two user.
 * @author Alessandro Franchini
 *
 */
public class PeerInterface extends JFrame {
	
	private static final long serialVersionUID = 1L;
	JPanel pannello;
	PeerCommunication tread;
	public User peer;
	public JTextArea messaggi;
	public JTextArea write;
	public JButton send;
	public JLabel nome;
	private String label;
	
	/**
	 * The constructor
	 * @param tt the thread of communication
	 * @param temp the user
	 */
	public PeerInterface(PeerCommunication tt, User temp){
		peer = temp;
		tread = tt;
		setTitle("Gossip");
		setSize(500,500);
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
            	for(int i = 0; i<GossipInterface.conn.size();i++){
            		if(peer.equals(GossipInterface.conn.get(i).name))
            			GossipInterface.conn.removeElementAt(i);
            	}            	
            	peer.setConn(0);
            	try {
					tread.so.close();
				} catch (Exception e1) {
					System.out.println("Socket gi� chiuso");
				}

            }
        });
		pannello = new JPanel();
		pannello.setLayout(null);
		if(!peer.isOnline())
			label = peer.getNick() + ", (Non in linea)";
		else
			label = peer.getNick() + ", (In linea)";
		int lung = peer.getNick().length() *10;
		nome = new JLabel(label);
		nome.setBounds(200,5,lung+200,20);
		pannello.add(nome);
		messaggi = new JTextArea();
		messaggi.setEditable(false);
		messaggi.setFont(new Font("Serif",Font.ROMAN_BASELINE,16));
		JScrollPane scrollMex = new JScrollPane(messaggi);
		scrollMex.setBounds(25,30,440,290);
		pannello.add(scrollMex);
		write = new JTextArea();
		write.setEditable(true);
		JScrollPane scrollWrite = new JScrollPane(write);
		scrollWrite.setBounds(25,330,350,120);
		pannello.add(scrollWrite);
		send = new JButton("Invia");
		send.setBounds(380,330,84,119);
		pannello.add(send);
		send.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				if(write.getDocument().getLength()==0)
					return;
				Message send = new Message(write.getText(),peer,ClientCore.myself);
				printMex(write.getText(),ClientCore.myself.getNick(),send.getDate().toString());
				tread.sendMex(send);
				write.setText("");
			}
			
		});
		getRootPane().setDefaultButton(send);
		getContentPane().add(pannello);
	}
	
	/**
	 * This method changes the string of the status.
	 * @param state the new status
	 */
	public void changeState(boolean state){
		if(state == true){
			label = label = peer.getNick() + ", (In linea)";
			nome.setText(label);
			nome.repaint();
		}
		else {
			label = peer.getNick() + ", (Non in linea)";
			nome.setText(label);
			nome.repaint();
		}
	}
	
	/**
	 * Prints the received message in the graphic interface
	 * @param mex the receveid message
	 * @param writer the sender of the message
	 */
	public void printMex(String mex, String writer, String date){
		String temp = writer + " write [" + date + "]: ";
		String temp1 = mex + "\n";
		messaggi.append(temp);
		messaggi.append(temp1);
	}
	
	

}
