package testing;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.InetAddress;
import java.security.Principal;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import messageServerP.FileBackupper;
import messageServerP.ManagedUser;

import bootstrapP.RegisteredUser;

public class FileBackupper2 {
	
	public static void main(String[] args) throws IOException, ClassNotFoundException{
		File usersFile = new File("provaUtenti.bak");
		usersFile.delete();
		FileBackupper fb=new FileBackupper("provaUtenti");
		List<ManagedUser> rUsers = new Vector<ManagedUser>();
		
		rUsers.add(new ManagedUser("marco",InetAddress.getLocalHost(),100,"ciao1"));
		rUsers.add(new ManagedUser("palla",InetAddress.getLocalHost(),200,"ciao2"));
		rUsers.add(new ManagedUser("drugo",InetAddress.getLocalHost(),300,"ciao3"));
		
		fb.removeBackuppedUser(rUsers.get(0));
		printContent(fb);

		fb.backupUser(rUsers.get(0));
		printContent(fb);
		
		fb.removeBackuppedUser(rUsers.get(0));
		printContent(fb);
		
		fb.backupWholeData(rUsers);
		printContent(fb);
		
		rUsers.remove(new ManagedUser("marco",InetAddress.getLocalHost(),100,"ciao1"));
		fb.backupWholeData(rUsers);
		printContent(fb);
		
		List<ManagedUser> restored = new Vector<ManagedUser>();
		fb.restoreData(restored);
		printVectContent(restored);
					
	}
	
	public static void printContent(FileBackupper fb) throws IOException, ClassNotFoundException{
		List<ManagedUser> mu = new Vector<ManagedUser>();
		fb.restoreData(mu);
		
		for (int i=0;i<mu.size();i++){
			System.out.println("User letto: "+mu.get(i).getNick());
		}
	}
	public static void printVectContent(List<ManagedUser> list) {
		for (int i=0;i<list.size();i++){
			System.out.println("User letto da lista: "+list.get(i).getNick());
		}
	}
}
