package testing;

import java.rmi.Naming;

import common.Message;
import common.MessageServer;
import common.User;
import common.interfaces.BSForServletInterface;
import common.interfaces.MSForServletInterface;
import common.interfaces.exceptions.*;

public class Servlet30GetMsPwAddFriends {

	public static void main (String[] argv){
		BSForServletInterface bsInt = null;
		try {
			//test da effettuare dopo i test 10 e 25
			//Prove di un solo utente su un solo MS...
			bsInt = (BSForServletInterface) Naming.lookup("rmi://localhost:1111/gossipBS");
			User myself = new User("marco",null,0,true,true);
			MSForServletInterface msi=null;
			MessageServer ms = bsInt.getMS(myself);
			msi = (MSForServletInterface) Naming.lookup("rmi://"+ms.getIP().getHostName()+":"+ms.getPort()+"/gossipMS");
			try{
				msi.setState(myself, "pwsbagliata", true);
				System.out.println("ERRORE: Password sbagliata non segnalata");
			}catch (WrongPasswordException e){
				System.out.println("Password sbagliata OK: "+e);
			}
			msi.setState(myself, "pallone", true);
			try{
				//prova: invio messaggio a utente non amico
				msi.forwardMessage(new Message("il plesso solare e' importante\ntrattalo bene",myself,myself));
				System.out.println("Il forward a utente non bloccato consentito OK.");
			} catch (NotAllowedException e){
				System.out.println("ERRORE Forward non consentito: "+e);
			}
			//prova addtofriends
			try{
				//mi fingo un utente che non esiste
				msi.addToFriends(new User("uomoinvisibile",null,0,true,true), "pwsbagliata", myself);
				System.out.println("ERRORE: Utente inesistente non segnalato.");
			} catch (UserNotManagedException e){
				System.out.println("Utente non gestito OK: "+e);
			} 
			
			try{
				//utente esistente ma password sbagliata
				msi.addToFriends(myself, "pwsbagliata", myself);
				System.out.println("ERRORE: pw sbagliata non segnalata.");
			} catch (WrongPasswordException e){
				System.out.println("Password sbagliata OK: "+e);
			}
			
			//inserimento corretto
			msi.addToFriends(myself, "pallone", myself);
			System.out.println("Primo inserimento OK. ");
			
			try{
				//riprovo l'inserimento corretto
				msi.addToFriends(myself, "pallone", myself);
				System.out.println("ERRORE: doppio inserimento non segnalato.");
			} catch (UserAlreadyInsertedException e){
				System.out.println("Doppio inserimento errato OK: "+e);
			}

		    
		} catch (Exception e){
			e.printStackTrace();
		}

		

	}
}
